﻿Imports System.Collections.Generic
Imports System.Linq
Imports System.Text


Friend Class clsCommon


    Private Sub New()
    End Sub


    Public Shared Function GetSameLengthString(ByVal txt As String, ByVal len As Integer) As String
        If txt.Length >= len Then
            Return txt.Substring(0, len)
        Else
            Return String.Format("{0,-" & len.ToString() & "}", txt)
        End If
    End Function


    ''' <summary>
    ''' 受信バイトを文字列に変換
    ''' </summary>
    Public Shared Function GetStringFromBytes(ByVal data As Byte()) As String
        Dim text As String = clsConst.encUni.GetString(data)
        Return text
    End Function



    ''' <summary>
    ''' 文字列をバイトに変換
    ''' </summary>
    Public Shared Function GetBytesFromString(ByVal text As String) As Byte()
        Dim data As [Byte]() = clsConst.encUni.GetBytes(text)
        Return data
    End Function



    ''' <summary>
    ''' Msgからエンコード済みの送信Byte配列を得る
    ''' </summary>
    Public Shared Function GetBytesFromMessage(ByVal m As clsMessage) As Byte()
        Dim str As String = m.ReceiveFrom + clsConst.SEPALETER + m.SendTo + clsConst.SEPALETER + m.Key + clsConst.SEPALETER + m.Value
        Dim data As Byte() = clsCommon.GetBytesFromString(str)
        Return data
    End Function



    ''' <summary>
    ''' 受信データと名前からMessageを得る
    ''' </summary>
    Public Shared Function GetMessageFromBytes(ByVal data As Byte()) As clsMessage
        'dataは [FROM][TO][KEY][VALUE] とSepaleterで区切られて送られてくる
        Dim m As New clsMessage()
        Dim text As String = clsCommon.GetStringFromBytes(data)
        Dim SepaleterIndex As New List(Of Integer)()

        'セパレータを見つける
        For i As Integer = 0 To text.Length - 1
            If text(i) = clsConst.SEPALETER Then
                SepaleterIndex.Add(i)
            End If
        Next

        '文字の長さを計算しておく
        Dim len As New List(Of Integer)()
        len.Add(SepaleterIndex(0))
        len.Add(SepaleterIndex(1) - SepaleterIndex(0) - 1)
        len.Add(SepaleterIndex(2) - SepaleterIndex(1) - 1)

        m.SpecialKey = Not clsCommon.keyCheck(text.Substring(SepaleterIndex(1) + 1, len(2)))
        'データの格納
        m.ReceiveFrom = text.Substring(0, len(0))
        m.SendTo = text.Substring(SepaleterIndex(0) + 1, len(1))
        m.Key = text.Substring(SepaleterIndex(1) + 1, len(2))
        m.Value = text.Substring(SepaleterIndex(2) + 1)
        Return m
    End Function



    ''' <summary>
    ''' Keyが使えるか確認する
    ''' </summary>
    Public Shared Function keyCheck(ByVal key As String) As Boolean
        If clsConst.DEFINE_KEY.ContainsValue(key) Then
            '一致しちゃった
            '使えません。
            Return False
        End If
        'セパレータをふくんでいない？
        If key.Contains(clsConst.SEPALETER) Then
            'セパレータと一致すると使えません。
            Return False
        End If
        Return True
    End Function



    ''' <summary>
    ''' Nameが使えるか確認する
    ''' </summary>
    Public Shared Function nameCheck(ByVal name As String) As Boolean
        'セパレータをふくんでいない？
        If name.Contains(clsConst.SEPALETER) Then
            'セパレータと一致すると使えません。
            Return False
        End If
        Return True
    End Function



    ''' <summary>
    ''' 文字列をセパレータで分割する
    ''' </summary>
    Public Shared Function SepaleteString(ByVal text As String, ByVal sepaleter As Char) As List(Of String)
        Dim items As New List(Of String)()
        Dim SepaleterIndex As New List(Of Integer)()
        'セパレータを見つける
        For i As Integer = 0 To text.Length - 1
            If text(i) = sepaleter Then
                SepaleterIndex.Add(i)
            End If
        Next

        'セパレータが見つからなければそのまま帰す
        If SepaleterIndex.Count = 0 Then
            items.Add(text)
            Return items
        End If

        If SepaleterIndex.Count <> 0 Then
            For i As Integer = 0 To SepaleterIndex.Count - 1
                If i = 0 Then
                    items.Add(text.Substring(0, SepaleterIndex(0)))
                Else
                    items.Add(text.Substring(SepaleterIndex(i - 1) + 1, SepaleterIndex(i) - SepaleterIndex(i - 1) - 1))
                End If
            Next
        End If
        items.Add(text.Substring(SepaleterIndex(SepaleterIndex.Count - 1) + 1))

        Return items
    End Function

End Class
